---------------------------------------------------------------
--                                                           
--  ROBOT INTERPRETER
--  By: Martin Carlisle and Keith Shomper     
--                                                           
--  Instruction_Dialog
--  Description : variables and routines for modifying the
--                memory contents
--                       
--  By: Martin Carlisle
--                                         
-- ROBOT INTERPRETER is free software; you can redistribute it and/or 
-- modify it without restriction.  However, we ask that you
-- please retain the original author information, and clearly  
-- indicate if it has been modified.
--  
-- ROBOT INTERPRETER is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty
-- of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
--
---------------------------------------------------------------
with Mcc.Gui.Container.Window;
with Mcc.Gui.Widget.Text_Entry;
with Get_Instruction_Window;
with State;
with RobotADT;
with Simulation_GUI;
with Mcc.Gui.Keys;
package body Instruction_Dialog is

   function To_Number(Binary : in String) return Integer is
      result : integer := 0;
   begin
      for i in Binary'range loop
         result := result * 2;
         if binary(i)='1' then
            result := result + 1;
         end if; 
      end loop;
      return result;
   end To_Number;


   procedure Ok is
      Good_String : Boolean := True;
   begin
      Get_Instruction_Window.Read_Window(Good_String);
      if Length(Instruction_String)=8 then
         declare
            Value : String(1..11) := "2#00000000#";
         begin
            Value(3..10) := To_String(Instruction_String);
            for I in 3..10 loop
               if Value(I)/='0' and Value(I)/='1' then
                  Good_String := False;
                  exit;
               end if;
            end loop;
         end;
      else
         Good_String := False;
      end if;
      if not Good_String then
         Mcc.Gui.Bell;
         Mcc.Gui.Widget.Text_Entry.Highlight(
            Get_Instruction_Window.Instruction_Text);
      else
         State.Robot_Modified := True;
         RobotADT.set_address (
            R     => State.Robot,
            loc   => Instruction_Y, 
            state => To_Number(To_String(Instruction_String)));
         Simulation_Gui.Set_Instruction(Instruction_Y);
         Mcc.Gui.Container.Window.Destroy(
            Get_Instruction_Window.Get_Instruction_Window);
      end if;
   end Ok;

  
   --------
   -- Ok --
   --------

   procedure Ok (Obj : in out Mcc.Gui.Widget.Button.Button'Class) is
   begin
      Ok;
   end Ok;


   procedure Key_Callback (
      Obj   : in out Mcc.Gui.Sized_Object'Class;
      Event : in     Mcc.Gui.Key_Event) is
      use Mcc.Gui;
   begin
      if Event.Action=Release and Event.Key=Mcc.Gui.Keys.Enter then
         Ok;
      elsif Event.Action=Release and Mcc.Gui.Widget.Text_Entry.Get_Text_Length(
         Get_Instruction_Window.Instruction_Text) > 8 then
         Mcc.Gui.Bell;
         declare
            Current : String := Mcc.Gui.Widget.Text_Entry.Get_Text(
               Get_Instruction_Window.Instruction_Text);
         begin
            Mcc.Gui.Widget.Text_Entry.Set_Text(
               Obj => Get_Instruction_Window.Instruction_Text,
               Text => Current(Current'First..Current'First+7));
         end;
      end if;
   end Key_Callback;

end Instruction_Dialog;

